//Copyright (c) 2010, Mario aka carkid111

//THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
//AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
//IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
//ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
//LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
//CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
//SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
//INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
//CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
//ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
//OF THE POSSIBILITY OF SUCH DAMAGE.

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace Bubble_POP
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Pop : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SoundEffect pop;
        SoundEffectInstance popi;
        Texture2D backr;
        Texture2D b1;
        Texture2D b2;
        Texture2D resetbutten;
        Boolean[] bubble;
        AccelerometerState state;
        SpriteBatch spriteBatch;
        const int n = 15;

        public Pop()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            // Frame rate is 30 fps by default for Zune.
            TargetElapsedTime = TimeSpan.FromSeconds(1 / 30.0);
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here
            bubble = new Boolean[n];
            setTrue();

        
            base.Initialize();
        }

        public void setTrue()
        {
            for (int i = 0; i < n; i++)
                bubble[i] = true;
        }

        public void reset()
        {
            setTrue();

        }
        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            pop = Content.Load<SoundEffect>("pop");
            backr = Content.Load<Texture2D>("back");
            b1 = Content.Load<Texture2D>("b1");
            b2 = Content.Load<Texture2D>("b2");
            resetbutten = Content.Load<Texture2D>("reset");

            popi = pop.CreateInstance();

            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here

           state = Accelerometer.GetState();
           Vector3 acc = state.Acceleration;

           TouchCollection touches = TouchPanel.GetState();
           foreach (TouchLocation location in touches)
           {
                if ((location.Position.X > 0 && location.Position.X < 64 && location.Position.Y > 1 && location.Position.Y < 77)&& bubble[0] == !false)
                {
                    popi.Play();
                    bubble[0] = false;
                    //top row 1
                }
                if ((location.Position.X > 104 && location.Position.X < 168 && location.Position.Y > 1 && location.Position.Y < 77) && bubble[1] == !false)
                {  
                    popi.Play();
                    bubble[1] = false;
                    //top row 2
                }
                if ((location.Position.X > 208 && location.Position.X < 272 && location.Position.Y > 1 && location.Position.Y < 77) && bubble[2] == !false)
                {
                    popi.Play();
                    bubble[2] = false;
                    //top row 3
                }
                if ((location.Position.X > 50 && location.Position.X < 114 && location.Position.Y > 77 && location.Position.Y < 154) && bubble[3] == !false)
                {
                    popi.Play();
                    bubble[3] = false;
                    //second row 1
                }
                if ((location.Position.X > 156 && location.Position.X < 220 && location.Position.Y > 77 && location.Position.Y < 154) && bubble[4] == !false)
                {
                    popi.Play();
                    bubble[4] = false;
                    //second row 2
                }
                if ((location.Position.X > 0 && location.Position.X < 64 && location.Position.Y > 154 && location.Position.Y < 231) && bubble[5] == !false)
                {
                    popi.Play();
                    bubble[5] = false;
                    //third row 1
                }
                if ((location.Position.X > 104 && location.Position.X < 168 && location.Position.Y > 154 && location.Position.Y < 231) && bubble[6] == !false)
                {
                    popi.Play();
                    bubble[6] = false;
                    //third row 2
                }
                if ((location.Position.X > 208 && location.Position.X < 272 && location.Position.Y > 154 && location.Position.Y < 231) && bubble[7] == !false)
                {
                    popi.Play();
                    bubble[7] = false;
                    //third row 3
                }
                if ((location.Position.X > 50 && location.Position.X < 114 && location.Position.Y > 231 && location.Position.Y < 308) && bubble[8] == !false)
                {
                    popi.Play();
                    bubble[8] = false;
                    //forth row 1
                }
                if ((location.Position.X > 156 && location.Position.X < 220 && location.Position.Y > 231 && location.Position.Y < 308) && bubble[9] == !false)
                {
                    popi.Play();
                    bubble[9] = false;
                    //forth row 2
                }
                if ((location.Position.X > 0 && location.Position.X < 64 && location.Position.Y > 308 && location.Position.Y < 385) && bubble[10] == !false)
                {
                    popi.Play();
                    bubble[10] = false;
                    //fifth row 1
                }
                if ((location.Position.X > 104 && location.Position.X < 168 && location.Position.Y > 308 && location.Position.Y < 385) && bubble[11] == !false)
                {
                    popi.Play();
                    bubble[11] = false;
                    //fifth row 2
                }
                if ((location.Position.X > 208 && location.Position.X < 272 && location.Position.Y > 308 && location.Position.Y < 385) && bubble[12] == !false)
                {
                    popi.Play();
                    bubble[12] = false;
                    //fifth row 3
                }
                if ((location.Position.X > 50 && location.Position.X < 114 && location.Position.Y > 385 && location.Position.Y < 462) && bubble[13] == !false)
                {
                    popi.Play();
                    bubble[13] = false;
                    //sixth row 1
                }
                if ((location.Position.X > 156 && location.Position.X < 220 && location.Position.Y > 385 && location.Position.Y < 462) && bubble[14] == !false)
                {
                    popi.Play();
                    bubble[14] = false;
                    //sixth row 2
                }
                if ((location.Position.X > 229 && location.Position.X < 272 && location.Position.Y > 435 && location.Position.Y < 480))
                {
                    popi.Stop();
                    reset();
                    //reset feild
                }
            }
           
               

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.White);
            spriteBatch.Begin();
            spriteBatch.Draw(backr, new Vector2(0, 0), Color.White);

            //d1 = not poped bubble | d2 = poped bubble

            if (bubble[0]== true)//top row 1
            {
                spriteBatch.Draw(b1, new Vector2(1, 1), Color.White);
            }
            if(bubble[0]==false)//top row 1
            {
                spriteBatch.Draw(b2, new Vector2(1, 1), Color.White);
            }
            if (bubble[1] == true)//top row 2
            {
                spriteBatch.Draw(b1, new Vector2(104, 1), Color.White);
            }
            if (bubble[1] == false)//top row 2
            {
                spriteBatch.Draw(b2, new Vector2(104, 1), Color.White);
            }
            if (bubble[2] == true)//top row 3
            {
                spriteBatch.Draw(b1, new Vector2(208, 1), Color.White);
            }
            if (bubble[2] == false)//top row 3
            {
                spriteBatch.Draw(b2, new Vector2(208, 1), Color.White);
            }
            if (bubble[3] == true)//second row 1
            {
                spriteBatch.Draw(b1, new Vector2(50, 77), Color.White);
            }
            if (bubble[3] == false)//second row 1
            {
                spriteBatch.Draw(b2, new Vector2(50, 77), Color.White);
            }
            if (bubble[4] == true)//second row 2
            {
                spriteBatch.Draw(b1, new Vector2(156, 77), Color.White);
            }
            if (bubble[4] == false)//second row 3
            {
                spriteBatch.Draw(b2, new Vector2(156, 77), Color.White);
            }
            if (bubble[5] == true)//third row 1
            {
                spriteBatch.Draw(b1, new Vector2(0, 154), Color.White);
            }
            if (bubble[5] == false)//third row 1
            {
                spriteBatch.Draw(b2, new Vector2(0, 154), Color.White);
            }
            if (bubble[6] == true)//third row 2
            {
                spriteBatch.Draw(b1, new Vector2(104, 154), Color.White);
            }
            if (bubble[6] == false)//third row 2
            {
                spriteBatch.Draw(b2, new Vector2(104, 154), Color.White);
            }
            if (bubble[7] == true)//third row 3
            {
                spriteBatch.Draw(b1, new Vector2(208, 154), Color.White);
            }
            if (bubble[7] == false)//third row 3
            {
                spriteBatch.Draw(b2, new Vector2(208, 154), Color.White);
            }
            if (bubble[8] == true)//forth row 1
            {
                spriteBatch.Draw(b1, new Vector2(50, 231), Color.White);
            }
            if (bubble[8] == false)//forth row 1
            {
                spriteBatch.Draw(b2, new Vector2(50, 231), Color.White);
            }
            if (bubble[9] == true)//forth row 2
            {
                spriteBatch.Draw(b1, new Vector2(156, 231), Color.White);
            }
            if (bubble[9] == false)//forth row 2
            {
                spriteBatch.Draw(b2, new Vector2(156, 231), Color.White);
            }
            if (bubble[10] == true)//fifth row 1
            {
                spriteBatch.Draw(b1, new Vector2(0, 308), Color.White);
            }
            if (bubble[10] == false)//fifth row 1
            {
                spriteBatch.Draw(b2, new Vector2(0, 308), Color.White);
            }
            if (bubble[11] == true)//fifth row 2
            {
                spriteBatch.Draw(b1, new Vector2(104, 308), Color.White);
            }
            if (bubble[11] == false)//fifth row 2
            {
                spriteBatch.Draw(b2, new Vector2(104, 308), Color.White);
            }
            if (bubble[12] == true)//fifth row 3
            {
                spriteBatch.Draw(b1, new Vector2(208, 308), Color.White);
            }
            if (bubble[12] == false)//fifth row 3
            {
                spriteBatch.Draw(b2, new Vector2(208, 308), Color.White);
            }
            if (bubble[13] == true)//fifth row 3
            {
                spriteBatch.Draw(b1, new Vector2(50, 385), Color.White);
            }
            if (bubble[13] == false)//fifth row 3
            {
                spriteBatch.Draw(b2, new Vector2(50, 385), Color.White);
            }
            if (bubble[14] == true)//fifth row 3
            {
                spriteBatch.Draw(b1, new Vector2(156, 385), Color.White);
            }
            if (bubble[14] == false)//fifth row 3
            {
                spriteBatch.Draw(b2, new Vector2(156, 385), Color.White);
            }

            //reset button
            spriteBatch.Draw(resetbutten, new Vector2(229, 435), Color.White);
            //reset button
            spriteBatch.End();

            // TODO: Add your drawing code here

            base.Draw(gameTime);
        }
    }
}
